// sysvar.cpp
// Revision 8-sep-2003

#include "blassic.h"
#include "sysvar.h"
#include "charset.h"
#include "trace.h"

namespace {

BlChar system_vars [sysvar::EndSysVar];

} // namespace


void sysvar::init ()
{
	set16 (GraphicsWidth, 0);
	set16 (GraphicsHeight, 0);
	set16 (NumArgs, 0);
	set16 (VersionMajor, version::Major);
	set16 (VersionMinor, version::Minor);
	set16 (VersionRelease, version::Release);
	set32 (AutoInit, 10);
	set32 (AutoInc, 10);
	set32 (CharGen, reinterpret_cast <size_t> (charset::data) );
	set (ShellResult, 0);
	set (TypeOfVal, 0); // VAL simple, number only.
	set (TypeOfNextCheck, 0); // Strict next check
	set (TypeOfDimCheck, 0); // Need erase before dim already dimensioned
	set16 (MaxHistory, 100);
	set (Flags1, 0); // LOCATE style Microsoft (row, col),
			// TAB style normal.
	#ifdef BLASSIC_USE_WINDOWS
	const short defaultprinterline= 1;
	#else
	const short defaultprinterline= 0;
	#endif
	set (PrinterLine, defaultprinterline);
	set32 (MaxFnLevel, 1000); // Seems a good limit.
	set16 (DebugLevel, 0);
	set16 (Zone, 8);
}

size_t sysvar::address ()
{
	return reinterpret_cast <size_t> (system_vars);
}

void sysvar::set_cpc ()
{
	// Set values for Amstrad CPC compatibility.
	TraceFunc tr ("sysvar::set_cpc");

	set (Flags1, get (Flags1) | LocateStyle);
}

void sysvar::set_spectrum ()
{
	// Set values for Spectrum compatibility.
	TraceFunc tr ("sysvar::set_spectrum");

	set (TypeOfVal, 1);
	set (TypeOfNextCheck, 1);
	set (TypeOfDimCheck, 1);
	set (Flags1, get (Flags1) | TabStyle);
}

void sysvar::set (size_t var, char value)
{
	system_vars [var]= value;
}

void sysvar::set16 (size_t var, short value)
{
	poke16 (system_vars + var, value);
}

void sysvar::set32 (size_t var, long value)
{
	poke32 (system_vars + var, value);
}

BlChar sysvar::get (size_t var)
{
	return system_vars [var];
}

unsigned short sysvar::get16 (size_t var)
{
	return static_cast <unsigned short> (peek16 (system_vars + var) );
}

unsigned long sysvar::get32 (size_t var)
{
	return peek32 (system_vars + var);
}

// Fin de sysvar.cpp
